clear screen

connect / AS sysdba

set echo on
set termout on
set feed on

show user

DECLARE
  SERVLET_NAME VARCHAR2(32) := 'orawsv';
BEGIN
  DBMS_XDB.deleteServletMapping(SERVLET_NAME);
  DBMS_XDB.deleteServlet(SERVLET_NAME);
  DBMS_XDB.addServlet(NAME => SERVLET_NAME,
                              LANGUAGE => 'C',
                              DISPNAME => 'Oracle Query Web Service',
                              DESCRIPT => 'Servlet for issuing queries as a Web Service',
                              SCHEMA => 'XDB');
  DBMS_XDB.addServletSecRole(SERVNAME => SERVLET_NAME,
                             ROLENAME => 'XDB_WEBSERVICES',
                             ROLELINK => 'XDB_WEBSERVICES');
  DBMS_XDB.addServletMapping(PATTERN => '/orawsv/*',
                             NAME => SERVLET_NAME);
END;
/

pause

--
def USERNAME=SCOTT
--
def PASSWORD=tiger
--

pause
begin
  DBMS_NETWORK_ACL_ADMIN.DROP_ACL('localhost.xml');
  dbms_network_acl_admin.create_acl('localhost.xml', 'ACL for 127.0.0.1', '&USERNAME', true, 'connect');
  dbms_network_acl_admin.assign_acl('localhost.xml', '127.0.0.1');
end;
/
COMMIT
/

pause
GRANT XDB_WEBSERVICES TO &USERNAME
/
GRANT XDB_WEBSERVICES_OVER_HTTP TO &USERNAME
/
GRANT XDB_WEBSERVICES_WITH_PUBLIC TO &USERNAME
/

pause

clear screen

connect &USERNAME/&PASSWORD

set echo on
set termout on
set feed on

show user

--
var url varchar2(700)
--
SET long 10000
--

BEGIN
  :url :=   'http://&USERNAME:&PASSWORD@127.0.0.1:' || dbms_xdb.getHttpPort() || '/orawsv?wsdl';
end;
/
print url
pause
--
SET long 10000 pages 0
--
SELECT  httpuritype( :url ).getXML() FROM dual
/
pause

CREATE OR REPLACE procedure OBJECTTYPES 
( v_owner        IN varchar2
, v_object_type OUT varchar2
)
AS

CURSOR c_1
IS
   select   object_type
   from     all_objects
   where    owner=v_owner
   group by object_type;

BEGIN

   FOR r_1 IN c_1 LOOP
   BEGIN
   	IF c_1%FOUND THEN
   		v_object_type:=r_1.object_type;
   	END IF;
   END;		
	END LOOP; 
END;
/

pause
BEGIN
  :url :=   'http://&USERNAME:&PASSWORD@127.0.0.1:' || dbms_xdb.getHttpPort() || '/orawsv/SCOTT/OBJECTTYPES?wsdl';
end;
/

print url
pause
--
SET long 10000 pages 0
--
SELECT  httpuritype( :url ).getXML() FROM dual
/
